component Terminal {

   field intstr: char[] = new char[11];
   field charstr: char[] = new char[1];
   field hexstr: char[] = new char[2];

   method printInt(i: int)
   {
      local pos: boolean = true;
      local ind: int = 10;

      if (i == 0) {
         intstr[ind] = '0';
      } else {
         if (i < 0) {
	    i = -1 * i;
	    pos = false;
	 }

         while (i > 0) {
	    intstr[ind] = ((i % 10) + '0'::int) :: char;
	    ind--;
	    i = i / 10;
	 }

	 if (pos == false) {
	    intstr[ind] = '-';
	 } else {
	    ind++;
	 }
      }

      while (ind < intstr.length) {
         ind = ind + USART0.transmit(intstr, ind, intstr.length - ind);
      }
   }

   method printHex(c: char)
   {
      local digit: int;
      local raw: 8;

      raw = c :: 8;

      digit = (raw & 0xF) :: int;
      if (digit < 10)
         hexstr[1] = (digit + '0' :: int)::char;
      else
         hexstr[1] = (digit - 10 + 'A' :: int)::char;

      digit = ((raw & 0xF0) >> 4) :: int;
      if (digit < 10)
         hexstr[0] = (digit + '0' :: int)::char;
      else
         hexstr[0] = (digit - 10 + 'A' :: int)::char;

      printString(hexstr);
   }

   method printChar(c: char)
   {
      charstr[0] = c;
      printString(charstr);
   }

   method printString(string: char[])
   {
      local i: int = 0;

      while (i < string.length) {
         i = i + USART0.transmit(string, i, string.length - i);
      }
   }

   method nextLine()
   {
      charstr[0] = '\n';
      printString(charstr);
   }
}

